@import url(https://fonts.googleapis.com/css?family=Courgette|Oswald);

$color-dark: #06cde1;
$color-mid: #fff;
$color-lite: #fefefe;

body {
  background-color: $color-dark;
  font-family: "Oswald", sans-serif;
}

main {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  width: 80%;
  max-width: 600px;
  margin: 36px auto;
}

header {
  text-align: center;
}

h2 {
  font-size: 3rem;
  margin-bottom: 30px;
  font-family: "Courgette", sans-serif;
  letter-spacing: -1px;
  text-shadow: lighten($color-dark, 10%) 1px 1px 0;
}

button {
  position: relative;
  z-index: 1;
  overflow: hidden;
  width: 100%;
  padding: 10px 30px;
  background-color: darken($color-dark, 10%);
  color: $color-lite;
  border: none;
  font-size: 1.2rem;
  font-weight: bold;
  text-transform: uppercase;
  text-shadow: darken($color-dark, 10%) 1px 1px 0;
  letter-spacing: 0.06em;
  cursor: pointer;
  outline: none;
  box-shadow: darken($color-dark, 20%) 0 4px 0,
    darken($color-dark, 4%) 0 -1px 0 inset;
  transform: translateY(-4px);
  transition: box-shadow 0.2s ease-out, color 0.2s 0.4s ease-out,
    transform 0.2s ease-out;

  &:before {
    opacity: 0;
    content: "Big Mac";
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    margin: auto;
    z-index: 2;
    color: darken($color-dark, 10%);
    padding: 10px 30px;
    transform: translateY(8px);
    transition: 0.2s ease-out;
  }

  &:after {
    opacity: 0;
    content: "";
    position: absolute;
    top: -300px;
    right: 0;
    bottom: -300px;
    left: 0;
    margin: auto;
    color: white;
    width: 0;
    height: 0;
    border-radius: 100%;
    background-color: darken($color-dark, 20%);
    transition: 0.2s ease-out;
  }

  &.open {
    color: darken($color-dark, 10%);
    box-shadow: darken($color-dark, 20%) 0 0 0;
    transform: translateY(0);
    transition: 0.2 ease-out;

    &:before {
      opacity: 1;
      color: $color-lite;
      text-shadow: none;
      transform: translateY(0);
      transition: 0.2s 0.4s ease-out;
    }

    &:after {
      opacity: 1;
      width: 600px;
      height: 600px;
    }
  }
}

table {
  opacity: 1;
  padding: 0;
  margin: 0 auto 36px;
  width: 100%;
  text-shadow: lighten($color-mid, 4%) 1px 1px 0;
  text-align: left;
  vertical-align: middle;
  border-collapse: separate;
  border-spacing: 0;

  tr {
    backface-visibility: hidden;
    transform-origin: 50% 0%;
    transform: perspective(350px) rotateX(-90deg);
    animation: swingOut 0.6s ease-out forwards;
    transition: box-shadow 1s ease-out;
    @for $i from 1 to 12 {
      &:nth-child(#{$i}) {
        animation-delay: $i * -0.1s;
      }
    }

    &:hover td {
      transform: scale(1.05) translateX(2px);
      background-color: darken($color-mid, 15%);
    }
  }

  &.closed {
    opacity: 0;
  }

  &.open {
    transition: box-shadow 1s 1s ease-out;
    box-shadow: darken($color-dark, 10%) 0 10px 20px;

    tr {
      animation: swingIn 0.6s ease-out forwards;
      @for $i from 1 to 12 {
        &:nth-child(#{$i}) {
          animation-delay: $i * 0.1s;
        }
      }
    }
  }
}

th {
  box-sizing: border-box;
  position: relative;
  padding: 16px 12px;
  font-size: 22px;
  color: darken($color-dark, 30%);
  background-color: darken($color-mid, 4%);
  box-shadow: darken($color-mid, 8%) 0 -4px 0 inset;

  &:first-child {
    font-size: 28px;
    font-family: "Courgette", sans-serif;
    letter-spacing: -1px;
  }
}

td {
  box-sizing: border-box;
  position: relative;
  padding: 12px;
  color: darken($color-dark, 20%);
  background-color: $color-mid;
  transition: 0.2s ease-in-out;

  &:first-child {
    font-family: "Courgette", sans-serif;
    font-size: 20px;
    letter-spacing: -1px;
    color: darken($color-dark, 30%);
  }
}

@media (max-width: 465px) {
  h2 {
    font-size: 36px;
  }

  button {
    letter-spacing: 0;
  }

  table {
    tr {
      &:hover td {
        transform: scale(1) translateX(0);
        background-color: $color-mid;
        &:first-child {
          background-color: darken($color-mid, 3%);
        }
      }
    }

    th:first-child {
      box-shadow: none;
      padding-bottom: 0;
    }

    td,
    th {
      width: 33.3333%;
      display: block;
      float: left;
      text-align: center;
      &:first-child {
        width: 100%;
        clear: both;
        background-color: darken($color-mid, 3%);
      }
    }

    td:not(:first-child) {
      border-bottom: 2px solid darken($color-mid, 8%);
    }
  }
}

@keyframes swingIn {
  0% {
    transform: perspective(350px) rotateX(-90deg);
  }
  40% {
    transform: perspective(350px) rotateX(30deg);
  }
  60% {
    transform: perspective(350px) rotateX(-20deg);
  }
  80% {
    transform: perspective(350px) rotateX(10deg);
  }
  100% {
    transform: perspective(350px) rotateX(0deg);
  }
}

@keyframes swingOut {
  0% {
    transform: perspective(350px) rotateX(0deg);
  }
  40% {
    transform: perspective(350px) rotateX(10deg);
  }
  60% {
    transform: perspective(350px) rotateX(-20deg);
  }
  80% {
    transform: perspective(350px) rotateX(30deg);
  }
  100% {
    transform: perspective(350px) rotateX(-90deg);
  }
}
